.\" DO NOT MODIFY THIS FILE! it was generated by rd2
.TH MILTER\-MANAGER 1 "July 2009" "milter manager" "milter manager's manual"
.SH NAME
.PP
milter\-manager \- an effective anti\-spam and anti\-virus solution with milters
.SH SYNOPSIS
.PP
\&\fBmilter\-manager\fP [\fIoption ...\fP]
.SH DESCRIPTION
.PP
milter\-manager is a milter that provides an effective anti\-spam and anti\-virus solution with milters.
.PP
milter\-manager provides a platform to use milters effectively and flexibly. milter\-manager has embedded Ruby interpreter that is used for dynamic milter applicable condition. milter\-manager can provide the platform by embedded Ruby interpreter.
.PP
milter\-manager reads its configuration file. The current configuration can be confirmed by \-\-show\-config option:
.nf
\&    % milter\-manager \-\-show\-config
.fi
.PP
milter\-manager also provides other options that overrides configurations specified in configuration file.
.SH Options
.TP
.fi
.B
\-\-help
Shows available options and exits.
.TP
.fi
.B
\-\-connection\-spec=SPEC
Specifies a socket that accepts connections from MTA. SPEC should be formatted as one of the followings:
.IP
.B
\(bu
unix:PATH
.IP
.B
\(bu
inet:PORT
.IP
.B
\(bu
inet:PORT@HOST
.IP
.B
\(bu
inet:PORT@[ADDRESS]
.IP
.B
\(bu
inet6:POST
.IP
.B
\(bu
inet6:PORT@HOST
.IP
.B
\(bu
inet6:PORT@[ADDRESS]

Examples:
.IP
.B
\(bu
unix:/var/run/milter/milter\-manager.sock
.IP
.B
\(bu
inet:10025
.IP
.B
\(bu
inet:10025@localhost
.IP
.B
\(bu
inet:10025@[127.0.0.1]
.IP
.B
\(bu
inet6:10025
.IP
.B
\(bu
inet6:10025@localhost
.IP
.B
\(bu
inet6:10025@[::1]

This option overrides "manager.connection_spec" in configuration file.
.TP
.fi
.B
\-\-config\-dir=DIRECTORY
Specifies a directory that includes milter\-manager's configuration file. milter\-manager tries to load DIRECTORY/milter\-manager.conf. If it isn't find, milter\-manager loads milter\-manager.conf in default directory.
.TP
.fi
.B
\-\-pid\-file=FILE
Saves process ID of milter\-manager to FILE.

This option overrides "manager.pid_file" in configuration file.
.TP
.fi
.B
\-\-user\-name=NAME
Runs milter\-manager as NAME user. milter\-manager should be started by root.

This option overrides "security.effective_user" in configuration file.
.TP
.fi
.B
\-\-group\-name=NAME
Runs milter\-manager as NAME group. milter\-manager should be started by root.

This option overrides "security.effective_group" in configuration file.
.TP
.fi
.B
\-\-socket\-group\-name=NAME
Changes group of UNIX domain socket for accepting connection by milter\-manager to NAME group. Specified group should be one of the effective user's supplementary groups.

This option overrides "manager.unix_socket_group" in configuration file.
.TP
.fi
.B
\-\-daemon
Runs milter\-manager as daemon process.

This option overrides "manager.daemon" in configuration file.
.TP
.fi
.B
\-\-no\-daemon
This option cancels the prior \-\-daemon option.
.TP
.fi
.B
\-\-show\-config
Shows the current configuration and exits. The output format can be used in configuration file. This option is useful for confirming registered milters and reporting your milter\-manager's configuration when you report milter\-manager's problems.
.TP
.fi
.B
\-\-verbose
Logs verbosely. Logs by syslog with "mail". If milter\-manager isn't daemon process, standard output is also used.

"MILTER_LOG_LEVEL=all" environment variable configuration has the same effect.
.TP
.fi
.B
\-\-version
Shows version and exits.
.SH EXIT STATUS
.PP
The exit status is 0 if milter starts to listen and non 0 otherwise. milter\-manager can't start to listen when connection spec is invalid format or other connection specific problems. e.g. the port number is already used, permission isn't granted for create UNIX domain socket and so on.
.SH FILES
.TP
.fi
.B
/usr/local/etc/milter\-manager/milter\-manager.conf
The default configuration file.
.SH EXAMPLE
.PP
The following example is good for debugging milter\-manager behavior. In the case, milter\-manager works in the foreground and logs are outputted to the standard output.
.nf
\&    % milter\-manager \-\-no\-daemon \-\-verbose
.fi
.SH SEE ALSO
.PP
.BR milter\-test\-server
(1),.BR milter\-test\-client
(1),.BR milter\-performance\-check
(1),.BR milter\-manager\-log\-analyzer
(1)

